var searchstring;
var myResults;
var location;
var collapsedState;

// have to set this as widget.system only support files up to 4K

var outputfile = 'yelloutput.txt';

function loaded() {
	
	collapsedState='YES';
	searchFill();
	calculateAndShowThumb(document.getElementById('results'));
	
	checkLocation();
	document.getElementById('searchInput').style.color = 'black';
	
	var doneButton = document.getElementById('done');
	createGenericButton (doneButton, 'Done', hidePrefs, 70);
	
	document.getElementById('results').innerHTML = "<br><br><br><br><br><br><br><br><br><center><b>Search by keyword/category?</b><br>Write the keyword or category starting with a dot<br>then optionally led by company name, e.g.: <i>.pub charlie</i></center>";
	document.getElementById('results').style.display="none";

}

if(window.widget) {
	widget.onremove = onremove;
	//calculateAndShowThumb(document.getElementById('results'));
}

function onremove() {
	if(myResults!=null) {
		myResults.cancel();
	}
}

function checkLocation() {
	location = widget.preferenceForKey('location');
	
	if ( (location==null) || (location==='United Kingdom') ) {
		widget.setPreferenceForKey('United Kingdom', 'location');
		location = 'United Kingdom';
		document.getElementById('smallStatus').innerHTML = '<br><br>Specify your town or postcode in preferences:';
		document.getElementById('smallStatus').style.display = 'block';
	}
	document.getElementById('locationset').value = location;
}


function checkWindow() {
	if(collapsedState==='YES') { expandWindow(); }
	else { collapseWindow(); }
}

function expandWindow() {
	//cosmetic stuff
	collapsedState='NO';
	MM_swapImage('background','','Images/yell_expanded.png',1);
	document.getElementById('parentDiv').style.display = 'block';
	document.getElementById('results').style.display = 'block';
	flip.style.top="217px";
	fliprollie.style.top="217px";
	smallStatus.style.top="192px";
	calculateAndShowThumb(document.getElementById('results'));
}

function collapseWindow() {
	collapsedState='YES';
	MM_swapImage('background','','Images/yell_collapsed.png',1);
	document.getElementById('parentDiv').style.display = 'none';
	document.getElementById('results').style.display = 'none';
	flip.style.top="34px";
	fliprollie.style.top="34px";
	smallStatus.style.top="8px";
}

function searchClear() {
	if(searchInput.value==='Enter search') {
		searchInput.value='';
	}
	document.getElementById('searchInput').style.color = 'black';
}

function searchFill() {
	if(searchInput.value==='') { 
		searchInput.value='Enter search';
		document.getElementById('searchInput').style.color = '#A1A1A1';
	}
	
}

function MM_preloadImages() { //v3.0
  var d=document; if(d.images){ if(!d.MM_p) d.MM_p=new Array();
    var i,j=d.MM_p.length,a=MM_preloadImages.arguments; for(i=0; i<a.length; i++)
    if (a[i].indexOf("#")!=0){ d.MM_p[j]=new Image; d.MM_p[j++].src=a[i];}}
}

function MM_swapImgRestore() { //v3.0
  var i,x,a=document.MM_sr; for(i=0;a&&i<a.length&&(x=a[i])&&x.oSrc;i++) x.src=x.oSrc;
}

function MM_findObj(n, d) { //v4.01
  var p,i,x;  if(!d) d=document; if((p=n.indexOf("?"))>0&&parent.frames.length) {
    d=parent.frames[n.substring(p+1)].document; n=n.substring(0,p);}
  if(!(x=d[n])&&d.all) x=d.all[n]; for (i=0;!x&&i<d.forms.length;i++) x=d.forms[i][n];
  for(i=0;!x&&d.layers&&i<d.layers.length;i++) x=MM_findObj(n,d.layers[i].document);
  if(!x && d.getElementById) x=d.getElementById(n); return x;
}

function MM_swapImage() { //v3.0
  var i,j=0,x,a=MM_swapImage.arguments; document.MM_sr=new Array; for(i=0;i<(a.length-2);i+=3)
   if ((x=MM_findObj(a[i]))!=null){document.MM_sr[j++]=x; if(!x.oSrc) x.oSrc=x.src; x.src=a[i+2];}
}

function readInFile(filename) { 
    req = new XMLHttpRequest(); 
    req.open("GET", filename ,false); 
    req.send(null); 
    response = req.responseText; 
    if (response) { 
        return response; 
    } 
    return null 
}

function processRequest(search_term) {
	
	if(myResults!=null) {
		myResults.cancel();
	}
	
	location = widget.preferenceForKey('location');
	var searchPlus = encodeURI(search_term.replace(/[\s]/gi, '+'));
	var locationPlus = encodeURI(location.replace(/[\s]/gi, '+'));
	
	if (collapsedState==='YES') { expandWindow(); }	
	
	document.getElementById('results').innerHTML = '<br><br><center>Searching, please wait...<br><br><img src="Images/waiting.gif"></center>';
	calculateAndShowThumb(document.getElementById('results'));

	searchstring = '/usr/bin/php -f Scripts/yell.php ' + searchPlus + ' ' + locationPlus + ' > ' + outputfile;
	myResults = widget.system(searchstring, endHandler);
	
}

function endHandler(result) {

	calculateAndShowThumb(document.getElementById('results'));

	if(myResults.status===0) {
   
   		var theOutput = readInFile(outputfile)
   		document.getElementById('results').innerHTML = theOutput;
   		calculateAndShowThumb(document.getElementById('results'));
   		hideWait();
   		myResults.close();
	}
}

function showPrefs() {
    var front = document.getElementById("front");
    var back = document.getElementById("back");

    if (window.widget)
        widget.prepareForTransition("ToBack");
        
	document.getElementById('smallStatus').style.display = 'none';
    front.style.display="none";
    fliprollie.style.display="none";
    back.style.display="block";

    if (window.widget)
        setTimeout ('widget.performTransition();', 0);
    
}

function hidePrefs() {

	widget.setPreferenceForKey(document.getElementById('locationset').value, 'location');

    var front = document.getElementById("front");
    var back = document.getElementById("back");

    if (window.widget)
        widget.prepareForTransition("ToFront");

    back.style.display="none";
    front.style.display="block";

	checkLocation();
    
    if(collapsedState==='NO') { expandWindow(); }
	else { collapseWindow(); }

    if (window.widget)
        setTimeout ('widget.performTransition();', 0);     

}

